/* Actions (message types) */
mtype = { nop, c0_t7, c0_t9, c0_t6, c0_t5, c0_t4, c0_t3, c0_t2, c0_t8, c0_t1, c0_t0 };

/* Inter-process channels */

/* Environement<->process channels */
chan p0 = [0] of {mtype};

/* Environment process */
active proctype Environment()
{
  do
  :: p0 ! c0_t7
  :: p0 ! c0_t9
  :: p0 ! c0_t6
  :: p0 ! c0_t5
  :: p0 ! c0_t4
  :: p0 ! c0_t3
  :: p0 ! nop
  :: p0 ! c0_t2
  :: p0 ! c0_t8
  :: p0 ! c0_t1
  :: p0 ! c0_t0
  od
}

/* Action channel */
chan act = [0] of {mtype};

/* Most recent message event */
mtype lastAction = nop;

/* Action listener */
active proctype Listener()
{
  atomic {
    do
    :: act ? lastAction ->
  step: skip
    od
  }
}

/* Process 0 */
active proctype Proc0()
{
  int state = 0;
  do
  :: state == 0 ->
    atomic {
      if
      :: p0 ? nop ->

        state = 6;
      fi
    }
  :: state == 6 ->
    atomic {
      if
      :: p0 ? c0_t5 ->
        act ! c0_t5;
        state = 1;
      fi
    }
  :: state == 1 ->
    atomic {
      if
      :: p0 ? c0_t0 ->
        act ! c0_t0;
        state = 2;
      fi
    }
  :: state == 2 ->
    atomic {
      if
      :: p0 ? c0_t1 ->
        act ! c0_t1;
        state = 3;
      fi
    }
  :: state == 3 ->
    atomic {
      if
      :: p0 ? c0_t2 ->
        act ! c0_t2;
        state = 4;
      fi
    }
  :: state == 4 ->
    atomic {
      if
      :: p0 ? c0_t3 ->
        act ! c0_t3;
        state = 5;
      :: p0 ? c0_t9 ->
        act ! c0_t9;
        state = 7;
      fi
    }
  :: state == 5 ->
    atomic {
      if
      :: p0 ? c0_t4 ->
        act ! c0_t4;
        state = 6;
      fi
    }
  :: state == 7 ->
    atomic {
      if
      :: p0 ? c0_t6 ->
        act ! c0_t6;
        state = 8;
      fi
    }
  :: state == 8 ->
    atomic {
      if
      :: p0 ? c0_t7 ->
        act ! c0_t7;
        state = 9;
      fi
    }
  :: state == 9 ->
    atomic {
      if
      :: p0 ? c0_t8 ->
        act ! c0_t8;
        state = 4;
      fi
    }
  od
}

#define p_c0_t7	 (lastAction == c0_t7)
#define p_c0_t9	 (lastAction == c0_t9)
#define p_c0_t6	 (lastAction == c0_t6)
#define p_c0_t5	 (lastAction == c0_t5)
#define p_c0_t4	 (lastAction == c0_t4)
#define p_c0_t3	 (lastAction == c0_t3)
#define p_c0_t2	 (lastAction == c0_t2)
#define p_c0_t8	 (lastAction == c0_t8)
#define p_c0_t1	 (lastAction == c0_t1)
#define p_c0_t0	 (lastAction == c0_t0)


ltl p1	 { (p_c0_t2 || p_c0_t4) V (p_c0_t2 || p_c0_t4 || !p_c0_t8 || (!p_c0_t7 U p_c0_t3)) }	 /* true */
ltl p2	 { p_c0_t2 V (!p_c0_t1 || p_c0_t2 || []!p_c0_t7) }	 /* false */
ltl p3	 { p_c0_t2 V (p_c0_t2 || !p_c0_t3 || <>p_c0_t7) }	 /* true */
ltl p4	 { !(p_c0_t5 || p_c0_t9) U p_c0_t8 }	 /* false */
ltl p5	 { <>(p_c0_t3 V (!p_c0_t1 || p_c0_t3)) }	 /* true */
ltl p6	 { p_c0_t1 V (p_c0_t1 || !p_c0_t8 || (!p_c0_t4 U p_c0_t5)) }	 /* true */
ltl p7	 { <>(p_c0_t3 V (p_c0_t3 || !p_c0_t5)) }	 /* true */
ltl p8	 { [](!p_c0_t2 && (!p_c0_t9 || (!p_c0_t0 U p_c0_t4))) }	 /* false */
ltl p9	 { (p_c0_t1 || p_c0_t4) V (p_c0_t1 || p_c0_t4 || !p_c0_t6 || (p_c0_t1 V (p_c0_t1 || !p_c0_t7))) }	 /* true */
ltl p10	 { (p_c0_t1 || p_c0_t6) V (p_c0_t1 || !p_c0_t3 || p_c0_t6) }	 /* true */
ltl p11	 { p_c0_t5 V (p_c0_t5 || !p_c0_t7 || <>p_c0_t5) }	 /* true */
ltl p12	 { (p_c0_t2 || p_c0_t5) V (p_c0_t2 || p_c0_t5 || !p_c0_t8 || (p_c0_t7 V (!p_c0_t0 || p_c0_t7))) }	 /* true */
ltl p13	 { p_c0_t8 V (p_c0_t8 || !p_c0_t9 || <>p_c0_t3) }	 /* false */
ltl p14	 { (p_c0_t6 || p_c0_t9) V (p_c0_t6 || p_c0_t9 || !(p_c0_t5 || p_c0_t7)) }	 /* false */
ltl p15	 { <>(p_c0_t0 V (p_c0_t0 || !p_c0_t3)) }	 /* true */
ltl p16	 { (p_c0_t3 || p_c0_t8) V (!p_c0_t2 || p_c0_t3 || p_c0_t8 || (p_c0_t4 V (p_c0_t4 || !p_c0_t5))) }	 /* true */
ltl p17	 { []((!p_c0_t7 || (!p_c0_t8 U p_c0_t5)) && (!p_c0_t1 || []!p_c0_t6)) }	 /* false */
ltl p18	 { p_c0_t4 V (!p_c0_t1 || p_c0_t4) }	 /* false */
ltl p19	 { p_c0_t5 V (p_c0_t5 || !p_c0_t7 || (p_c0_t5 V (!p_c0_t0 || p_c0_t5))) }	 /* true */
ltl p20	 { (p_c0_t1 || p_c0_t7) V (p_c0_t1 || p_c0_t7 || !(p_c0_t0 || p_c0_t9)) }	 /* false */
